<?PHP

/// Library of functions and constants for module mobilequiz

// There is nothing interesting here, this is just the standard stuff that
// every module has to have


function mobilequiz_add_instance($mobilequiz) {
/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will create a new instance and return the id number 
/// of the new instance.

	global $CFG;
	require_once("../config.php");
	require_once($CFG->dirroot.'/mod/mobilequiz/locallib.php');

	list($parent_id, $name) = split(",",$mobilequiz->name,2);
	
    $mobilequiz->timemodified = time();
    $mobilequiz->parent_id = $parent_id;
    $mobilequiz->name = $name;

    // May have to add extra stuff in here #
	$response_dom = mobilequiz_create_midlet( $parent_id, $_POST['sms_number'] );
	#echo var_dump( $response_dom );
	if ( ! $response_dom || ! $response_dom->id ) {
		error( "Unable to create mobile quiz: $response_dom->error_message" ); 
		return false;
	}

	$mobilequiz->mobilestudy_id = $response_dom->id;
	$mobilequiz->mobilestudy_jar_url = $response_dom->midlet->jar_url;
	$mobilequiz->mobilestudy_jad_url = $response_dom->midlet->jad_url;

	$mobilequiz->mobilestudy_download_url_m = $response_dom->download_url_m;
    
    return insert_record("mobilequiz", $mobilequiz);
}


function mobilequiz_update_instance($mobilequiz) {
/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will update an existing instance with new data.

    $mobilequiz->timemodified = time();
    $mobilequiz->id = $mobilequiz->instance;

    # May have to add extra stuff in here #

    return update_record("mobilequiz", $mobilequiz);
}


function mobilequiz_delete_instance($id) {
/// Given an ID of an instance of this module, 
/// this function will permanently delete the instance 
/// and any data that depends on it.  

    if (! $mobilequiz = get_record("mobilequiz", "id", "$id")) {
        return false;
    }

    $result = true;

    # Delete any dependent records here #

    if (! delete_records("mobilequiz", "id", "$mobilequiz->id")) {
        $result = false;
    }

    return $result;
}

function mobilequiz_user_outline($course, $user, $mod, $mobilequiz) {
/// Return a small object with summary information about what a 
/// user has done with a given particular instance of this module
/// Used for user activity reports.
/// $return->time = the time they did it
/// $return->info = a short text description

    return $return;
}

function mobilequiz_user_complete($course, $user, $mod, $mobilequiz) {
/// Print a detailed representation of what a  user has done with 
/// a given particular instance of this module, for user activity reports.

    return true;
}

function mobilequiz_print_recent_activity($course, $isteacher, $timestart) {
/// Given a course and a time, this module should find recent activity 
/// that has occurred in mobilequiz activities and print it out. 
/// Return true if there was output, or false is there was none.

    global $CFG;

    return false;  //  True if anything was printed, otherwise false 
}

function mobilequiz_cron () {
/// Function to be run periodically according to the moodle cron
/// This function searches for things that need to be done, such 
/// as sending out mail, toggling flags etc ... 

    global $CFG;

    return true;
}

function mobilequiz_grades($mobilequizid) {
/// Must return an array of grades for a given instance of this module, 
/// indexed by user.  It also returns a maximum allowed grade.
///
///    $return->grades = array of grades;
///    $return->maxgrade = maximum allowed grade;
///
///    return $return;

   return NULL;
}

function mobilequiz_get_participants($mobilequizid) {
//Must return an array of user records (all data) who are participants
//for a given instance of mobilequiz. Must include every user involved
//in the instance, independient of his role (student, teacher, admin...)
//See other modules as example.

    return false;
}

function mobilequiz_scale_used ($mobilequizid,$scaleid) {
//This function returns if a scale is being used by one mobilequiz
//it it has support for grading and scales. Commented code should be
//modified if necessary. See forum, glossary or journal modules
//as reference.
   
    $return = false;

    //$rec = get_record("mobilequiz","id","$mobilequizid","scale","-$scaleid");
    //
    //if (!empty($rec)  && !empty($scaleid)) {
    //    $return = true;
    //}
   
    return $return;
}

//////////////////////////////////////////////////////////////////////////////////////
/// Any other mobilequiz functions go here.  Each of them must have a name that 
/// starts with mobilequiz_


?>
