<?PHP

function mobilestudy_add_quiz( $quiz_id, $quiz_xml, $sms_number ) {

	global $CFG;

	$mq_version = mobilequiz_get_version();

	// Create quiz on mobile study
	$server = $CFG->mobilequiz_server_url;

	// Force https access to mobilestudy server. The server will enforce this in the
	// near future
	$server 
		= preg_replace( '/^http:\/\/www.mobilestudy/', 'https://www.mobilestudy', $server);
	$server 
		= preg_replace( '/^http:\/\/mobilestudy/', 'https://www.mobilestudy', $server );

	$url = $server . '/api/v1/quiz/';

	$username = $CFG->mobilequiz_server_username;
	$password = $CFG->mobilequiz_server_password;

	$proxyhost = $CFG->proxyhost;
	$proxyport = $CFG->proxyport;
	$proxytype = $CFG->proxytype;
	$proxyusername = $CFG->proxyuser;
	$proxypassword = $CFG->proxypassword;

	//$url = $mobilestudy_url . 'api/v1/quiz/';
	//$username = $mobilestudy_username;
	//$password = $mobilestudy_password;
	//$proxy = $mobilestudy_proxy;
	//$proxyuserpwd = $mobilestudy_proxyuserpwd;
	
	$request = curl_init();

	curl_setopt( $request, CURLOPT_USERAGENT, "Moodle mobilequiz $mq_version" );

	# Remove query params from referer
	$referer = preg_replace( '/\?.*$/', '', $_SERVER['HTTP_REFERER'] );
	curl_setopt( $request, CURLOPT_REFERER, $referer );

	curl_setopt( $request, CURLOPT_SSL_VERIFYPEER, FALSE );
	curl_setopt( $request, CURLOPT_URL, $url );
	curl_setopt( $request, CURLOPT_USERPWD, "$username:$password" );
	curl_setopt( $request, CURLOPT_TIMEOUT, 45 );
	curl_setopt( $request, CURLOPT_RETURNTRANSFER, 1 );
	#curl_setopt( $request, CURLOPT_VERBOSE, 1 );
	curl_setopt( $request, CURLOPT_POST, 1 );
	$postfields =  "external_id=" . $quiz_id . "&xml=" . urlencode( $quiz_xml );
	if ( $sms_number ) {
		$sms_number = preg_replace( '/[\s-]/', '', $sms_number);
		$postfields = $postfields . "&sms_to=" . urlencode( $sms_number );
	}

	curl_setopt( $request, CURLOPT_POSTFIELDS, $postfields );

	#
	# Proxy configuration
	#
	if ( $proxyhost ) {
		curl_setopt( $request, CURLOPT_PROXY, $proxyhost );
	}
	if ( $proxyport ) {
		curl_setopt( $request, CURLOPT_PROXYPORT, $proxyport );
	}
	if ( $proxytype ) {
		curl_setopt( $request, CURLOPT_PROXYTYPE, $proxytype );
	}

	if ( $proxyusername ) {
		$namepass = $proxyusername;
		if ( $proxypassword ) {
			$namepass = $namepass . ':' . $proxypassword;
		}
		curl_setopt( $request, CURLOPT_PROXYUSERPWD, $namepass );
	}

	#
	# Send the request
	#
	$response = curl_exec($request);

	$response_code = curl_getinfo($request, CURLINFO_HTTP_CODE);
	if ( ! $response_code  ) {
		$response_code = 999;
		$response = curl_error($request);
	}

	curl_close($request);

	if ( $response_code >= 300 ) {
		$response = htmlspecialchars( $response );
		if ( empty( $response ) ) {
			$response = "HTTP Error: $response_code";
		}
		$response_dom = simplexml_load_string( "<p><error_code>$response_code</error_code><error_message>$response</error_message></p>" );
	}
	else {
		//echo $response . "\n";
		$response_dom = simplexml_load_string($response);
	}


	return $response_dom;
}

?>

